<?php

header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

include_once '../config/database.php';
include_once('../config/config.php');

$database = new Database();
$db = $database->getConnection();   

if ($_SERVER["REQUEST_METHOD"] == "GET") {
    
  $sql = "SELECT
              a.ID,
              a.fullname,
              a.cell,
              a.email,
              a.totalcredit,
              CAST(a.pointscredit AS DECIMAL(10,2)) AS pointscredit,
              CAST( a.pointsbalance AS DECIMAL(10,2)) AS pointsbalance,
              a.nickname,
              COUNT(b.ID) AS numberoforders,
              SUM(b.Total) AS totalpurchases
          FROM
              customer a
              LEFT JOIN Orders b ON b.CustomerID = a.ID
          GROUP BY
              a.ID";

  $stmt = $db->prepare($sql);
  $stmt->execute();
  $customers = $stmt->fetchAll(PDO::FETCH_ASSOC);

  echo json_encode($customers);
}
?>
