<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: *");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

include_once '../../config/database.php';

$database = new Database();
$db = $database->getConnection();

// Handle POST request
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    // Get the promotion data from the POST request
    $json = file_get_contents('php://input');
    $data = json_decode($json, true);
    
    $itemID = $data["itemId"];
    $flashsale_id = $data["flashsaleid"];
    $price = $data["price"];
    $quantity = $data["quantity"];
    
    try {
        $sql = "INSERT INTO flashsalesitems (ItemID, quantity, price, flashsaleID) VALUES (:itemID, :quantity, :price, :flashsale_id)";
        $stmt = $db->prepare($sql);
        $stmt->bindParam(':itemID', $itemID);
        $stmt->bindParam(':quantity', $quantity);
        $stmt->bindParam(':price', $price);
        $stmt->bindParam(':flashsale_id', $flashsale_id);
        
        if ($stmt->execute()) {
            // Return success response
            echo json_encode(["status" => "item addedsuccessfully"]);
        } else {
            http_response_code(500); // Internal Server Error
            echo json_encode(["error" => "Unable to insert data into database"]);
        }
    } catch (PDOException $e) {
        http_response_code(500); // Internal Server Error
        echo json_encode(["error" => $e->getMessage()]);
    }
}
?>
