<?PHP
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

require_once '../config/database.php';

   // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

$database = new Database();
$db = $database->getConnection();

if (isset($_GET['departmentID'], $_GET['branchid'])) {
    $DepartmentID = $_GET['departmentID'];
    $branchid = $_GET['branchid'];

    $sql = "SELECT item.id AS itemID, item.description, inventorylocationitems.cost, inventorylocationitems.price, inventorylocationitems.saleprice, inventorylocationitems.quantity, item.departmentID, item.categoryID, item.longdescription,item.is_serial,  CONCAT('https://admin.kassmatt.com/dist/img/items/',item.ID, '/', productimages.pic1) AS imageUrl
            FROM inventorylocationitems
            INNER JOIN item ON inventorylocationitems.itemID = item.id
             INNER JOIN productimages ON inventorylocationitems.itemID = productimages.itemID
            WHERE inventorylocationitems.inventoryLocation = :branchid AND item.departmentID = :DepartmentID AND inventorylocationitems.quantity > 2 AND productimages.pic1 IS NOT NULL";
            
        

    $stmt = $db->prepare($sql);
    $stmt->bindParam(":branchid", $branchid, PDO::PARAM_INT);
    $stmt->bindParam(":DepartmentID", $DepartmentID, PDO::PARAM_INT);
    $stmt->execute();

    $itemCount = $stmt->rowCount();

    if ($itemCount > 0) {
        $itemsArr = array();

        while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
            $e = array(
                "ID" => '224203' . $row['cost'] . '+' . $row['itemID'] . '+' . $row['price'],
                "itemID" => $row['itemID'],
                "description" => $row['description'],
                "cost" => $row['cost'],
                "price" => $row['price'],
                "saleprice" => $row['saleprice'],
                "quantity" => $row['quantity'],
                "departmentID" => $row['departmentID'],
                "categoryID" => $row['categoryID'],
                "longdescription" => $row['longdescription'],
                "image" => $row['imageUrl'],
                "serial" =>  $row['is_serial']
            );
            array_push($itemsArr, $e);
        }
        echo json_encode($itemsArr);
    } else {
       $noItemsArr = array();
        echo json_encode($noItemsArr);
    }
} else {
    http_response_code(400); // Bad Request
    echo json_encode(array("message" => " DepartmentID, and branchid are required."));
}
?>