<html>
  <head>
      <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <link rel="stylesheet" href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"
    integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A=="
    crossorigin=""/>
    <script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js"
    integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA=="
    crossorigin=""></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/leaflet-routing-machine/3.3.4/leaflet-routing-machine.css" integrity="sha512-pMIUjOQgRYOTZS3jC3c3V7sQ2LEsXs7lTjTbRNUlLrC85pjZrAeW8PvYKjzotwt1yXJtAae2tjK1IhFefnZoLw==" crossorigin="anonymous" referrerpolicy="no-referrer" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/leaflet-routing-machine/3.3.4/leaflet-routing-machine.js" integrity="sha512-Ny4vLJU6q30U1CHZj6QgvpYzjTZ3qGVjd9X/7iQsffKj56l1T8ziJrOnxLbNwEKdG7jK8hn9XO7HzFdTV/QI1g==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

<!-- Leaflet Routing Machine CSS -->
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/leaflet-routing-machine/dist/leaflet-routing-machine.css" />

<!-- Load Lodash -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/lodash.js/4.17.15/lodash.min.js"></script>

<!-- Leaflet Routing Machine JS -->
<script src="https://cdn.jsdelivr.net/npm/leaflet-routing-machine/dist/leaflet-routing-machine.js"></script>


<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/leaflet/1.7.1/leaflet.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/leaflet-routing-machine/3.2.12/leaflet-routing-machine.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/leaflet.awesome-markers/2.0.2/leaflet.awesome-markers.css" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/leaflet/1.7.1/leaflet.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/leaflet-routing-machine/3.2.12/leaflet-routing-machine.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/leaflet.awesome-markers/2.0.2/leaflet.awesome-markers.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/leaflet.polylineDecorator/1.6.0/leaflet.polylineDecorator.js"></script>
    
<style>
path.leaflet-interactive.animate {
    stroke-dasharray: 1920;
    stroke-dashoffset: 1920;
    animation: dash 5s linear 2s forwards;
}

@keyframes dash {
    to {
        stroke-dashoffset: 0;
    }
}

</style>




  
  </head>
  <body>
          
    <div id="map" style="height: 500px; width: 100%;"></div>



<script>
var map = L.map('map').setView([-1.28333, 36.81667], 12);

L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
    attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
}).addTo(map);

 var startIcon = L.icon({
        iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-yellow.png',
        iconSize: [25, 41],
        iconAnchor: [12, 41],
        popupAnchor: [0, -30]
    });

    var endIcon = L.icon({
        iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-violet.png',
        iconSize: [25, 41],
        iconAnchor: [12, 41],
        popupAnchor: [0, -30]
    });
    
    var shopIcon = L.icon({
    iconUrl: 'https://cdn.rawgit.com/pointhi/leaflet-color-markers/master/img/marker-icon-red.png',
    iconSize: [25, 41],
    iconAnchor: [12, 41],
    popupAnchor: [0, -30]
});



var markers = [];
var polyline = null;

// Function to draw the polyline on the map
function drawPolyline(locations) {
  if (locations.length > 1) {
    var latlngs = locations.map(function(location) {
      return L.latLng(location.Latitude, location.Longitude);
    });

    // Create a polyline using the latlngs array
    var polyline = L.polyline(latlngs, {
      color: 'blue',
      opacity: 1,
      weight: 2,
      className: 'animate'
    }).addTo(map);

    // Fit the map bounds to the polyline
    map.fitBounds(polyline.getBounds());
  }
}


// Function to add a marker or dot to the map and the markers array
function addMarker(location, isStart, isEnd) {
   
   
    if (isStart) {
       var marker = L.marker([location.Latitude, location.Longitude], {
            icon: startIcon
        });

        marker.bindPopup('Starting point'+ '<br/>' + location.LocationName + '<br/>' + location.LocationTime);

        marker.addTo(map);

        markers.push(marker);
    } else if(isEnd){
         var marker = L.marker([location.Latitude, location.Longitude], {
            icon: endIcon
        });

        marker.bindPopup('Ending point'+ '<br/>' + location.LocationName + '<br/>' + location.LocationTime);

        marker.addTo(map);

        markers.push(marker);
        
    }
}




// Function to add a marker for shop location
function addShopMarker(shop) {
    var marker = L.marker([shop.latitude, shop.longitude], {
        icon: shopIcon
    });

    marker.bindPopup(shop.name);

    marker.addTo(map);

    markers.push(marker);
}



function updateHistoricalLocations() {
  // Use AJAX to fetch the latest location from the server
  $.ajax({
    url: 'getHistoricalLocations.php',
    dataType: 'json',
    success: function(data) {
      if (data) {
        // Clear existing markers
        markers.forEach(function(marker) {
          marker.remove();
        });
        markers = [];

        var startLocation = data[0];
        var endLocation = data[data.length - 1];

        addMarker(startLocation, true, false);
        addMarker(endLocation, false, true);

        // Add markers for all historical locations and create the polyline
        data.forEach(function(location, index) {
          addMarker(location, index === 0, index === data.length - 1);
        });

        fetchShopLocations(endLocation); // Pass the final location as a parameter

        drawPolyline(data);
      }
    },
    error: function(xhr, status, error) {
      console.log(error);
    }
  });
}



// Function to fetch and display shop locations
function fetchShopLocations(currentLocation) {
  $.ajax({
    url: 'getShopLocations.php',
    dataType: 'json',
    success: function(data) {
      if (data) {
        // Add markers for shop locations and calculate distances
        data.forEach(function(shop) {
          addShopMarker(shop);

          // Calculate distance from shop to current location
          var shopLocation = L.latLng(shop.latitude, shop.longitude);
          var currentLatLng = L.latLng(currentLocation.Latitude, currentLocation.Longitude);
          var distance = shopLocation.distanceTo(currentLatLng) / 1000; // in kilometers

          // Update shop marker popup to include the distance
          markers[markers.length - 1].setPopupContent(shop.name + '<br/>Distance: ' + distance.toFixed(2) + ' km');
        });
      }
    },
    error: function(xhr, status, error) {
      console.log(error);
    }
  });
}







// Call the function to update the current and historical locations
updateHistoricalLocations();







</script>






  </body>
 
</html>
