<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: GET");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// Get the cell parameter from the request URL
$id = $_GET['id'];

// Connect to the database
include '../config/database2.php';

  // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

// Check connection
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Fetch the default address associated with the user

$stmt = $conn->prepare(" SELECT * from deliveryAddress where OrderID = ? ");


$stmt->bind_param("i", $id);
$stmt->execute();
$result = $stmt->get_result();




// If no default address was found, return null
if ($result->num_rows == 0) {
    $response = null;
} else {
    // Otherwise, create an address object
    $row = $result->fetch_assoc();
    $address = [
        'id' => $row['id'],
        'name' => $row['recipientname'],
        'email' => $row['recipientnameemail'],
        'mobile' => $row['recipientphone'],
        'road' => $row['road'],
        'building' => $row['building'],
        'houseNo' => $row['houseNo'],
        'floor' => $row['floor'],
        'region' => $row['region'],
        'moreinfor' => $row['moreinfor'],
        'default1' => $row['id']
    ];
    $response = $address;
}

// Return the address as a JSON response
echo json_encode($response);

$conn->close();
?>
