<?php
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

$json = file_get_contents('php://input');
$data = json_decode($json, true);

  // Validate the API key
$expected_api_key = "8L14irhDOhBUffrmiv2kqUSoSpeIK9D7JYDmsPVS9-M";

$received_api_key = isset($_SERVER['HTTP_AUTH']) ? trim($_SERVER['HTTP_AUTH']) : '';


if ($received_api_key !== $expected_api_key) {
    $response = [
        'success' => false,
        'message' => "Invalid API Key."
    ];
    echo json_encode($response);
    exit; // Terminate the script if the API key is invalid
}

$merchantRequestID = $data['merchantRequestID'];
$checkoutRequestID = $data['checkoutRequestID'];
$orderNumber = $data['orderNumber'];
$branchid = $data['branchid'];
$shipping = $data['shipping'];

// Connect to the database
include '../config/database2.php';

// Check connection
if ($conn->connect_error) {
  die("Connection failed: " . $conn->connect_error);
}

// Prepare and execute the SQL statement

$stmt = $conn->prepare("UPDATE payments_new SET `orderid` = ?, branchid = ?,`shippingFee` = ? WHERE merchant_request_id = ? AND checkout_request_id = ?");
$stmt->bind_param("sisss", $orderNumber, $branchid,$shipping, $merchantRequestID, $checkoutRequestID);



if ($stmt->execute()) {
  $response = [
    'success' => true,
    'message' => 'Order Payment updated successfully.'
  ];
} else {
  $response = [
    'success' => false,
    'message' => 'Failed to update order payment .'
  ];
}

echo json_encode($response);

$conn->close();
?>
